var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
export var convertActionToBase64 = function (action) {
    return Buffer.from(JSON.stringify(action)).toString('base64');
};
export var createCache = function (isCacheable, isValid) {
    var items = {};
    var add = function (action, value) {
        if (isCacheable(action)) {
            items[convertActionToBase64(action)] = __assign({}, value, { timestamp: new Date().getTime() });
        }
    };
    var remove = function (action) {
        delete items[convertActionToBase64(action)];
    };
    var get = function (action) {
        var response = items[convertActionToBase64(action)];
        var valid = response && isValid(response);
        if (response && valid) {
            return response;
        }
        if (response && !valid) {
            remove(action);
        }
    };
    return {
        add: add,
        get: get,
        items: items,
        remove: remove,
    };
};
