var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { useCallback, useContext, useEffect, useRef, useState } from 'react';
import { ClientContext } from '../../context/clientContext';
export var useQuery = function (action, initFetch) {
    if (initFetch === void 0) { initFetch = true; }
    var clientContext = useContext(ClientContext);
    var isMounted = useRef(true);
    var _a = useState(true), isLoading = _a[0], setLoading = _a[1];
    var _b = useState({ error: false }), response = _b[0], setResponse = _b[1];
    useEffect(function () {
        isMounted.current = true;
        if (initFetch) {
            handleQuery();
        }
        return function () {
            isMounted.current = false;
        };
    }, []);
    var handleQuery = useCallback(function (keepLastResponse) {
        if (!isMounted.current) {
            return;
        }
        setLoading(true);
        if (!keepLastResponse) {
            setResponse({ error: false });
        }
        clientContext.query(action).then(function (queryResponse) {
            handleResponse(queryResponse);
        });
    }, [action]);
    var handleResponse = function (queryResponse) {
        if (!isMounted.current) {
            return;
        }
        setLoading(false);
        setResponse(queryResponse);
    };
    return __assign({ loading: isLoading, query: handleQuery }, response);
};
